#!/usr/bin/perl -w
use strict;

#***** START OF CUSTOMIZATION AREA *****
my($BIGSERVER)="mainserv";
my($BIGSERVERIP)="192.168.100.1";
my($TESTSHARE)="//$BIGSERVER/TMP";
my($USERNAME)="username";

my(@ACLIENTS)=("WINCLI","DESK2");
my(@ACLIENTIPS)=("192.168.100.5","192.168.100.40");
#***** END OF CUSTOMIZATION AREA *****

my($LOGNAME)="diagnosis.log";
my($PASSWORD);

sub writelog
{
  system("echo \'$_[0]\' >> $LOGNAME");
  print "$_[0]\n";
}

sub writeTestHeader
{
  writelog("\n\n\n******** BEGIN TEST $_[0]  ********");
}

sub writeCommandHeader
{
  writelog("\n--- TEST $_[0] ---");
}

sub acquirePassword
{
  my($word);
  print "\n DO NOT ENTER YOUR PASSWORD UNLESS YOU TRUST THIS PROGRAM!\n";
  system "stty -echo";
  print "Password for $_[0]: ";
  chop($word = <STDIN>);
  print "\n";
  system "stty echo";
  return($word);
}

sub dotestparm
{
  &writeCommandHeader(1);
  system("echo > newline");
  my($endflag)="Press enter to see a dump of your service definitions";
  my($line);
  my(@lines)=`testparm < newline`;
  foreach $line (@lines) {
    chomp($line);
    last if $line eq $endflag;
    &writelog($line);
  }
}

sub shareTest
{
  my($tf)="testfile.tmp";
  my($tfback)="$tf\.tst";
  unlink $tfback;
  system("echo First line of test file > $tf");
  system("echo Last line of test file. >> $tf");
  &writeCommandHeader("7");
  my($command)="smbclient \'$TESTSHARE\' -c \"";
  $command=$command . "ls $tf; put $tf;get $tf $tfback;ls $tf";
  $command=$command . "\" -Uusername";

  #CAUTION: Write command before acquiring password!
  writelog($command);
  $command=$command . "%$PASSWORD";
  my($line);

  #CAUTION: Certain OS's show the password in ps -ax
  my(@lines)=`$command`;
  foreach $line (@lines) {
    chomp($line);
    &writelog($line);
  }
  print glob $tfback;
  my($scratch)=`ls -l --full-time $tfback`;
  writelog($scratch);
  $scratch=`date`;
  writelog("Time is $scratch"); 
}

sub do1test
{
  my($number, $command)=@_;
  &writeCommandHeader($number);
  &writelog($command);
  my(@output) = `$command`;
  my($line);
  foreach $line (@output) {
    chomp($line);
    &writelog($line);
  }
}

sub main
{
  $PASSWORD=&acquirePassword($USERNAME);
  my($element);
  system("rm $LOGNAME");
  &writelog("Start DIAGNOSIS.txt tests.\n\n");
 
  &writeTestHeader("1");
  &dotestparm();
  
  &writeTestHeader("1.5");
  &do1test("1.5", "ps -ax | grep mbd");
  
  &writeTestHeader("2");
  foreach $element (@ACLIENTIPS) {
    &do1test("2", "ping -c3 $element");
  }
  foreach $element (@ACLIENTS) {
    &do1test("2", "ping -c3 $element");
  }
  &writelog("!!!!! You must manually ping the server from the clients!");

  &writeTestHeader("3");
  &do1test("3", "smbclient -NL localhost");
  &do1test("3", "smbclient -NL $BIGSERVERIP");
  &do1test("3", "smbclient -NL $BIGSERVER");

  &writeTestHeader("4");
  &do1test("4", "nmblookup -B $BIGSERVER __SAMBA__");
  
  &writeTestHeader("5");
  foreach $element (@ACLIENTIPS) {
    &do1test("5", "nmblookup -B $element '*'");
  }
  foreach $element (@ACLIENTS) {
    &do1test("5", "nmblookup -B $element '*'");
  }

  &writeTestHeader("6");
  &do1test("6", "nmblookup -d 2 '*'");

  &writeTestHeader("7");
  &shareTest();

  &writelog("\n\n\n!! DO TESTS 8, 9 AND 10 ON WIN CLIENT !!");
}

&main();
